﻿using System;
using System.ComponentModel;
using System.Runtime.InteropServices;
using System.Threading;

namespace TestProject
{
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Import
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 입력 방지하기 - BlockInput(blocking)

        /// <summary>
        /// 입력 방지하기
        /// </summary>
        /// <param name="blocking">입력 방지 여부</param>
        /// <returns>처리 결과</returns>
        [return: MarshalAs(UnmanagedType.Bool)]
        [DllImport("user32", CharSet = CharSet.Auto, ExactSpelling = true, SetLastError = true)]
        private static extern bool BlockInput([In, MarshalAs(UnmanagedType.Bool)]bool blocking);

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Import
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            // 프로그램 실행 즉시 ALT + L 키를 눌러 윈도우즈 화면을 잠근 다음 5초후 화면 잠금을 해제한다.
            Thread.Sleep(5000);

            bool result = BlockInput(true);

            if(!result)
            {
                Win32Exception exception = new Win32Exception();

                Console.WriteLine($"{exception.NativeErrorCode}, {exception.ToString()}");
            }

            Console.WriteLine(result);
        }

        #endregion
    }
}